#include <stdio.h>

/* preko prostih faktora brojeva */
void zad1a1(int x, int y, int *sum, int *prod) {
  int p = 2;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  *sum = 0;
  *prod = 1;
  while (x > 1 && y > 1) {
    if (x % p == 0 && y % p == 0) {
      printf("%d, ", p);
      *sum += p;
      *prod *= p;
    }
    while (x % p == 0) x /= p;
    while (y % p == 0) y /= p;
    ++p;
  }
}

/* preko najvece zajednicke mjere */
void zad1a2(int x, int y, int *sum, int *prod) {
  int p = 2;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  *sum = 0;
  *prod = 1;
  while (y > 0) {
    int t = x % y;
    x = y;
    y = t;
  }
  while (x > 1) {
    if (x % p == 0) {
      printf("%d, ", p);
      *sum += p;
      *prod *= p;
      while (x % p == 0) x /= p;
    }
    ++p;
  }
}

/* pomocna funkcija */
int izokreni_apsolutnu_vrijednost(int x, int b) {
  int res = 0;
  if (x < 0) x = -x;
  while (x > 0) {
    res = b * res + (x % b);
    x /= b;
  }
  return res;
}

/* pomocna funkcija */
int broj_znamenaka(int x, int b) {
  int res = 0;
  if (x < 0) x = -x;
  while (x) {
    ++res;
    x /= b;
  }
  return res;
}

/* preko izokretanja (promjene redoslijeda znamenaka) brojeva */
void zad1b1(int x, int y, int b, int *sum, int *prod) {
  *sum = 0;
  *prod = 1;
  x = izokreni_apsolutnu_vrijednost(x, b);
  y = izokreni_apsolutnu_vrijednost(y, b);
  while (x > 0 && y > 0) {
    int zx = x % b, zy = y % b;
    if (zx == zy) {
      printf("%d, ", zx);
      *sum += zx;
      *prod *= zx;
    }
    x /= b; y /= b;
  }
}

/* preko skracivanja duljeg broja */
void zad1b2(int x, int y, int b, int *sum, int *prod) {
  int i, brZnamX = broj_znamenaka(x, b), brZnamY = broj_znamenaka(y, b);
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  if (brZnamX > brZnamY)
    for (i = brZnamY; i < brZnamX; ++i) x /= b;
  if (brZnamX < brZnamY)
    for (i = brZnamX; i < brZnamY; ++i) y /= b;
  *sum = 0;
  *prod = 1;
  while (x > 0) {
    int zx = x % b, zy = y % b;
    if (zx == zy) {
      printf("%d, ", zx);
      *sum += zx;
      *prod *= zx;
    }
    x /= b; y /= b;
  }
}

/* preko prostih faktora brojeva */
void zad1c1(int x, int y, int *sum, int *prod) {
  int p = 2;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  *sum = 0;
  *prod = 1;
  while (x > 1 && y > 1) {
    while (x % p == 0 && y % p == 0) {
      printf("%d, ", p);
      *sum += p;
      *prod *= p;
      x /= p;
      y /= p;
    }
    while (x % p == 0) x /= p;
    while (y % p == 0) y /= p;
    ++p;
  }
}

/* preko najvece zajednicke mjere */
void zad1c2(int x, int y, int *sum, int *prod) {
  int p = 2;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  *sum = 0;
  while (y > 0) {
    int t = x % y;
    x = y;
    y = t;
  }
  *prod = x;
  while (x > 1) {
    while (x % p == 0) {
      printf("%d, ", p);
      *sum += p;
      x /= p;
    }
    ++p;
  }
}

/* preko izokretanja (promjene redoslijeda znamenaka) brojeva */
void zad1d1(int x, int y, int b, int *sum, int *prod) {
  int m, M;
  *sum = 0;
  *prod = 1;
  x = izokreni_apsolutnu_vrijednost(x, b);
  y = izokreni_apsolutnu_vrijednost(y, b);
  m = (x < y ? x : y);
  M = (x > y ? x : y);
  while (m > 0) {
    int zm = m % b, zM = M % b;
    if (zm != zM) {
      printf("%d, ", zm);
      *sum += zm;
      *prod *= zm;
    }
    m /= b; M /= b;
  }
}

/* preko skracivanja duljeg broja */
void zad1d2(int x, int y, int b, int *sum, int *prod) {
  int i, brZnamX, brZnamY;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  if (x > y) { int t = x; x = y; y = t; }
  brZnamX = broj_znamenaka(x, b);
  brZnamY = broj_znamenaka(y, b);
  if (brZnamX > brZnamY)
    for (i = brZnamY; i < brZnamX; ++i) x /= b;
  if (brZnamX < brZnamY)
    for (i = brZnamX; i < brZnamY; ++i) y /= b;
  *sum = 0;
  *prod = 1;
  while (x > 0) {
    int zx = x % b, zy = y % b;
    if (zx != zy) {
      printf("%d, ", zx);
      *sum += zx;
      *prod *= zx;
    }
    x /= b; y /= b;
  }
}

int main(void) {
  int x, y, b, sum, prod;

  printf("x = "); scanf("%d", &x);
  printf("y = "); scanf("%d", &y);
  printf("b = "); scanf("%d", &b);

  printf("Zad 1, grupa A, nacin 1: "); zad1a1(x, y, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa A, nacin 2: "); zad1a2(x, y, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa B, nacin 1: "); zad1b1(x, y, b, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa B, nacin 2: "); zad1b2(x, y, b, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa C, nacin 1: "); zad1c1(x, y, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa C, nacin 2: "); zad1c2(x, y, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa D, nacin 1: "); zad1d1(x, y, b, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);
  printf("Zad 1, grupa D, nacin 2: "); zad1d2(x, y, b, &sum, &prod); printf("sum = %d, prod = %d\n", sum, prod);

  return 0;
}
