/* funkcije za pronalazenje najveceg (ne)parnog broja u nizu
   u slucaju da trazeni broj ne postoji funkcije vracaju -1 */
int max_parni(int* niz, int duljina){
    int i, index = -1;
    for(i = 0; i < duljina; ++i){
        if( index == -1 || (niz[i] % 2 == 0 && niz[i] > niz[index]) ) index = i;
    }
    return index;
}

int max_neparni(int* niz, int duljina){
    int i, index = -1;
    for(i = 0; i < duljina; ++i){
        if( index == -1 || (niz[i] % 2 == 1 && niz[i] > niz[index]) ) index = i;
    }
    return index;
}


/* funkcije za ubacivanje novog elementa u niz ispred, odnosno iza elementa na poziciji i
   ako pozicija i ne postoji u nizu, funkcije ne mijenjaju niz
   funkcije vracaju novu duljinu niza */
int insert_after(int* niz, int i, int novi, int duljina){
    int k;
    if(i < 0 || i >= duljina) return duljina;
    for(k = duljina; k > i; --i) niz[i] = niz[i-1];
    niz[i+1] = novi;
    return duljina + 1;
}

int insert_before(int* niz, int i, int novi, int duljina){
    int k;
    if(i < 0 || i >= duljina) return duljina;
    for(k = duljina; k >= i; --i) niz[i] = niz[i-1];
    niz[i] = novi;
    return duljina + 1;
}


/* rjesenja za sve 4 grupe, koristeci gore napisane funkcije */
int ubaci_A(int* niz, int duljina, int novi, int max){
    if(duljina == max) return duljina;
    return insert_before(niz, max_parni(niz, duljina), novi, duljina);
}

int ubaci_B(int* niz, int duljina, int novi, int max){
    if(duljina == max) return duljina;
    return insert_before(niz, max_neparni(niz, duljina), novi, duljina);
}

int ubaci_C(int* niz, int duljina, int novi, int max){
    if(duljina == max) return duljina;
    return insert_after(niz, max_parni(niz, duljina), novi, duljina);
}

int ubaci_D(int* niz, int duljina, int novi, int max){
    if(duljina == max) return duljina;
    return insert_after(niz, max_neparni(niz, duljina), novi, duljina);
}
