/* funkcije koje broje koliko (ne)parnih elemenata ima u nizu */
int count_odd(int* niz, int duljina){
    int i, count = 0;
    for(i = 0; i < duljina; ++i) if(niz[i] % 2 == 1) ++count;
    return count;
}

int count_even(int* niz, int duljina){
    int i, count = 0;
    for(i = 0; i < duljina; ++i) if(niz[i] % 2 == 0) ++count;
    return count;
}


/* funkcije za ubacivanje novog elementa u niz ispred, odnosno iza elementa na poziciji i */
int insert_after(int* niz, int i, int novi, int duljina){
    int k;
    for(k = duljina; k > i; --i) niz[i] = niz[i-1];
    niz[i+1] = novi;
}

int insert_before(int* niz, int i, int novi, int duljina){
    int k;
    for(k = duljina; k >= i; --i) niz[i] = niz[i-1];
    niz[i] = novi;
}


/* rjesenja za sve 4 grupe, koristeci gore napisane funkcije */
int ubaci_A(int* niz, int duljina, int novi, int max){
    int i;
    if( duljina + count_even(niz, duljina) > max ) return duljina;
    for(i = 0; i < duljina; ++i){
        if(niz[i] % 2 == 0){
            insert_before(niz, i, novi, duljina);
            ++i; /* jer moramo preskociti element ispred kojeg smo upravo ubacili  */
            ++duljina; /* jer smo upravo ubacili jedan element */
        }
    }
    return duljina;
}

int ubaci_B(int* niz, int duljina, int novi, int max){
    int i;
    if( duljina + count_odd(niz, duljina) > max ) return duljina;
    for(i = 0; i < duljina; ++i){
        if(niz[i] % 2 == 1){
            insert_before(niz, i, novi, duljina);
            ++i; /* jer moramo preskociti element ispred kojeg smo upravo ubacili novi element */
            ++duljina; /* jer smo upravo ubacili jedan element */
        }
    }
    return duljina;
}

int ubaci_C(int* niz, int duljina, int novi, int max){
    int i;
    if( duljina + count_even(niz, duljina) > max ) return duljina;
    for(i = 0; i < duljina; ++i){
        if(niz[i] % 2 == 0){
            insert_after(niz, i, novi, duljina);
            ++i; /* jer moramo preskociti element kojeg smo upravo ubacili novi element */
            ++duljina; /* jer smo upravo ubacili jedan element */
        }
    }
    return duljina;
}

int ubaci_D(int* niz, int duljina, int novi, int max){
    int i;
    if( duljina + count_odd(niz, duljina) > max ) return duljina;
    for(i = 0; i < duljina; ++i){
        if(niz[i] % 2 == 1){
            insert_after(niz, i, novi, duljina);
            ++i; /* jer moramo preskociti element kojeg smo upravo ubacili  */
            ++duljina; /* jer smo upravo ubacili jedan element */
        }
    }
    return duljina;
}